--------------------------------------------------------
-- VHDL code per il TestBench del registro con clock.
-- By Sebastiano Otupacca - PAP1 2008/2009, 30-04-2009
--------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

--------------------------------------------------------

entity Adder1_tb is

end Adder1_tb;

--------------------------------------------------------

architecture test of Adder1_tb is

  component Adder1
    generic(n: natural := 8);
    port(D : in std_logic_vector(n-1 downto 0);
         Q : out std_logic_vector(n-1 downto 0));
  end component;

  -- component generics
  constant n : natural := 8;

  -- component ports
  signal D : std_logic_vector(n-1 downto 0);
  signal Q : std_logic_vector(n-1 downto 0);

  constant step : time := 10 ns;

begin

  -- component instantiation
  Regcomp: Adder1
    generic map(n => n)
    port map(D => D,
             Q => Q);

  test_proc: process

  begin
    -- Itera i 256 valori possibili con 8 bit di dati
    for i in 0 to 2**n-1 loop
      D <= conv_std_logic_vector(i, n);
      wait for step;
    end loop;

    wait;
  end process test_proc;

end test;

--------------------------------------------------------
