--------------------------------------------------------
-- VHDL code per buffer a tre stati a n-bit.
-- By Sebastiano Otupacca - PAP1 2008/2009, 30-04-2009
--------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

--------------------------------------------------------

entity BufZ is

  generic(n: natural := 8);
  port(OE : in std_logic;                         -- Output enable
       D  : in std_logic_vector(n-1 downto 0);    -- Data input
       Q  : out std_logic_vector(n-1 downto 0));  -- Data output

end BufZ;

--------------------------------------------------------

architecture struct of BufZ is

begin

  Q <= D when OE = '1' else
       (others => 'Z');

end struct;

--------------------------------------------------------
