--------------------------------------------------------
-- VHDL code per decoder n => 2**n bit con enable.
-- By Sebastiano Otupacca - PAP1 2008/2009, 09-05-2009
--------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

--------------------------------------------------------

entity Decoder is

  generic(n: natural := 2);
  port(EN_N : in std_logic;                            -- Output Enable
       D    : in std_logic_vector(n-1 downto 0);       -- Data Input Selector
       Q    : out std_logic_vector(2**n-1 downto 0));  -- Decoder output

end Decoder;

--------------------------------------------------------

architecture rtl of Decoder is

begin

  Q <= conv_std_logic_vector(2**conv_integer(D), 2**n) when EN_N = '0' else
       (others => '0');

end rtl;

--------------------------------------------------------
