--------------------------------------------------------
-- VHDL code per il TestBench del decoder.
-- By Sebastiano Otupacca - PAP1 2008/2009, 09-05-2009
--------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

--------------------------------------------------------

entity Decoder_tb is

end Decoder_tb;

--------------------------------------------------------

architecture test of Decoder_tb is

  component Decoder
    generic(n: natural := 2);
    port(EN_N : in std_logic;
         D    : in std_logic_vector(n-1 downto 0);
         Q    : out std_logic_vector(2**n-1 downto 0));
  end component;

  -- component generics
  constant n : natural := 3;

  -- component ports
  signal EN_N : std_logic;
  signal D    : std_logic_vector(n-1 downto 0);
  signal Q    : std_logic_vector(2**n-1 downto 0);

  constant step : time := 10 ns;

begin

  -- component instantiation
  Decoder_comp: Decoder
    generic map(n => n)
    port map(EN_N => EN_N,
             D    => D,
             Q    => Q);

  test_proc: process

  begin
    D <= "011";
    EN_N <= '0';
    wait for step;

    D <= "101"; 
    wait for step;

    EN_N <= '1';
    wait for step;

    D <= "001"; 
    wait for step;

    EN_N <= '0';
    wait for step;

    wait;
  end process test_proc;

end test;

--------------------------------------------------------
