--------------------------------------------------------
-- VHDL code per il multiplexer a 2 input.
-- By Sebastiano Otupacca - PAP1 2008/2009, 30-04-2009
--------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

--------------------------------------------------------

entity MUX2 is

  generic(n: natural := 8);
  port(sel : in std_logic;                         -- Data Input Selector
       D0  : in std_logic_vector(n-1 downto 0);    -- Data input #0
       D1  : in std_logic_vector(n-1 downto 0);    -- Data input #1
       Q   : out std_logic_vector(n-1 downto 0));  -- Data output

end MUX2;

--------------------------------------------------------

architecture rtl of MUX2 is

begin

  Q <= D0 when sel = '0' else
       D1 when sel = '1' else
       (others => 'X');

end rtl;

--------------------------------------------------------
