--------------------------------------------------------
-- VHDL code per il TestBench del multiplexer a 2 input.
-- By Sebastiano Otupacca - PAP1 2008/2009, 30-04-2009
--------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

--------------------------------------------------------

entity MUX2_tb is

end MUX2_tb;

--------------------------------------------------------

architecture test of MUX2_tb is

  component MUX2
    generic(n: natural := 8);
    port(sel : in std_logic;
         D0  : in std_logic_vector(n-1 downto 0);
         D1  : in std_logic_vector(n-1 downto 0);
         Q   : out std_logic_vector(n-1 downto 0));
  end component;

  -- component generics
  constant n : natural := 8;

  -- component ports
  signal sel : std_logic;
  signal D0  : std_logic_vector(n-1 downto 0);
  signal D1  : std_logic_vector(n-1 downto 0);
  signal Q   : std_logic_vector(n-1 downto 0);

  constant step : time := 10 ns;

begin

  -- component instantiation
  MUX2comp: MUX2
    generic map(n => n)
    port map(sel => sel,
             D0  => D0,
             D1  => D1,
             Q   => Q);

  test_proc: process

  begin
    sel <= '0';
    D0 <= "01100101";
    D1 <= "10001100";
    wait for step;

    sel <= '1';
    wait for step;

    D0 <= "00010110";
    D1 <= "10101100";
    wait for step;

    sel <= '0';
    wait for step;

    wait;
  end process test_proc;

end test;

--------------------------------------------------------
