--------------------------------------------------------
-- VHDL code per il multiplexer a 4 input.
-- By Sebastiano Otupacca - PAP1 2008/2009, 30-04-2009
--------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

--------------------------------------------------------

entity MUX4 is

  generic(n: natural := 8);
  port(sel : in std_logic_vector(1 downto 0);      -- Data Input Selector
       D0  : in std_logic_vector(n-1 downto 0);    -- Data input #0
       D1  : in std_logic_vector(n-1 downto 0);    -- Data input #1
       D2  : in std_logic_vector(n-1 downto 0);    -- Data input #1
       D3  : in std_logic_vector(n-1 downto 0);    -- Data input #1
       Q   : out std_logic_vector(n-1 downto 0));  -- Data output

end MUX4;

--------------------------------------------------------

architecture rtl of MUX4 is

begin

  Q <= D0 when sel = "00" else
       D1 when sel = "01" else
       D2 when sel = "10" else
       D3 when sel = "11" else
       (others => 'X');

end rtl;

--------------------------------------------------------
