--------------------------------------------------------
-- VHDL code per il TestBench del multiplexer a 4 input.
-- By Sebastiano Otupacca - PAP1 2008/2009, 30-04-2009
--------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

--------------------------------------------------------

entity MUX4_tb is

end MUX4_tb;

--------------------------------------------------------

architecture test of MUX4_tb is

  component MUX4
    generic(n: natural := 8);
    port(sel : in std_logic_vector(1 downto 0);
         D0  : in std_logic_vector(n-1 downto 0);
         D1  : in std_logic_vector(n-1 downto 0);
         D2  : in std_logic_vector(n-1 downto 0);
         D3  : in std_logic_vector(n-1 downto 0);
         Q   : out std_logic_vector(n-1 downto 0));
  end component;

  -- component generics
  constant n : natural := 8;

  -- component ports
  signal sel : std_logic_vector(1 downto 0);
  signal D0  : std_logic_vector(n-1 downto 0);
  signal D1  : std_logic_vector(n-1 downto 0);
  signal D2  : std_logic_vector(n-1 downto 0);
  signal D3  : std_logic_vector(n-1 downto 0);
  signal Q   : std_logic_vector(n-1 downto 0);

  constant step : time := 10 ns;

begin

  -- component instantiation
  MUX4comp: MUX4
    generic map(n => n)
    port map(sel => sel,
             D0  => D0,
             D1  => D1,
             D2  => D2,
             D3  => D3,
             Q   => Q);

  test_proc: process

  begin
    sel <= "00";
    D0 <= "01100101";
    D1 <= "10001100";
    D2 <= "01110110";
    D3 <= "00111001";
    wait for step;

    sel <= "01";
    wait for step;

    sel <= "10";
    wait for step;

    sel <= "11";
    wait for step;

    D1 <= "11110101";
    D3 <= "01111101";
    wait for step;

    sel <= "01";
    wait for step;

    sel <= "0X";
    wait for step;

    sel <= "10";
    wait for step;

    wait;
  end process test_proc;

end test;

--------------------------------------------------------
