--------------------------------------------------------
-- VHDL code per il multiplexer a 8 input.
-- By Sebastiano Otupacca - PAP1 2008/2009, 30-04-2009
--------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

--------------------------------------------------------

entity MUX8 is

  generic(n: natural := 8);
  port(sel : in std_logic_vector(2 downto 0);      -- Data Input Selector
       D0  : in std_logic_vector(n-1 downto 0);    -- Data input #0
       D1  : in std_logic_vector(n-1 downto 0);    -- Data input #1
       D2  : in std_logic_vector(n-1 downto 0);    -- Data input #1
       D3  : in std_logic_vector(n-1 downto 0);    -- Data input #1
       D4  : in std_logic_vector(n-1 downto 0);    -- Data input #1
       D5  : in std_logic_vector(n-1 downto 0);    -- Data input #1
       D6  : in std_logic_vector(n-1 downto 0);    -- Data input #1
       D7  : in std_logic_vector(n-1 downto 0);    -- Data input #1
       Q   : out std_logic_vector(n-1 downto 0));  -- Data output

end MUX8;

--------------------------------------------------------

architecture rtl of MUX8 is

begin

  Q <= D0 when sel = "000" else
       D1 when sel = "001" else
       D2 when sel = "010" else
       D3 when sel = "011" else
       D4 when sel = "100" else
       D5 when sel = "101" else
       D6 when sel = "110" else
       D7 when sel = "111" else
       (others => 'X');

end rtl;

--------------------------------------------------------
