--------------------------------------------------------
-- VHDL code per il TestBench del multiplexer a 8 input.
-- By Sebastiano Otupacca - PAP1 2008/2009, 30-04-2009
--------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

--------------------------------------------------------

entity MUX8_tb is

end MUX8_tb;

--------------------------------------------------------

architecture test of MUX8_tb is

  component MUX8
    generic(n: natural := 8);
    port(sel : in std_logic_vector(2 downto 0);
         D0  : in std_logic_vector(n-1 downto 0);
         D1  : in std_logic_vector(n-1 downto 0);
         D2  : in std_logic_vector(n-1 downto 0);
         D3  : in std_logic_vector(n-1 downto 0);
         D4  : in std_logic_vector(n-1 downto 0);
         D5  : in std_logic_vector(n-1 downto 0);
         D6  : in std_logic_vector(n-1 downto 0);
         D7  : in std_logic_vector(n-1 downto 0);
         Q   : out std_logic_vector(n-1 downto 0));
  end component;

  -- component generics
  constant n : natural := 8;

  -- component ports
  signal sel : std_logic_vector(2 downto 0);
  signal D0  : std_logic_vector(n-1 downto 0);
  signal D1  : std_logic_vector(n-1 downto 0);
  signal D2  : std_logic_vector(n-1 downto 0);
  signal D3  : std_logic_vector(n-1 downto 0);
  signal D4  : std_logic_vector(n-1 downto 0);
  signal D5  : std_logic_vector(n-1 downto 0);
  signal D6  : std_logic_vector(n-1 downto 0);
  signal D7  : std_logic_vector(n-1 downto 0);
  signal Q   : std_logic_vector(n-1 downto 0);

  constant step : time := 10 ns;

begin

  -- component instantiation
  MUX8comp: MUX8
    generic map(n => n)
    port map(sel => sel,
             D0  => D0,
             D1  => D1,
             D2  => D2,
             D3  => D3,
             D4  => D4,
             D5  => D5,
             D6  => D6,
             D7  => D7,
             Q   => Q);

  test_proc: process

  begin
    sel <= "000";
    D0 <= "01100101";
    D1 <= "10001100";
    D2 <= "01110110";
    D3 <= "00111001";
    wait for step;

    sel <= "001";
    wait for step;

    sel <= "010";
    wait for step;

    sel <= "011";
    wait for step;

    D1 <= "11110101";
    D3 <= "01111101";
    wait for step;

    sel <= "001";
    wait for step;

    sel <= "00X";
    wait for step;

    sel <= "010";
    wait for step;

    sel <= "100";  -- D4 non inizializzato
    wait for step;

    sel <= "000";
    wait for step;

    wait;
  end process test_proc;

end test;

--------------------------------------------------------
