--------------------------------------------------------
-- VHDL code per il TestBench del Merge Bits.
-- By Sebastiano Otupacca - PAP1 2008/2009, 30-04-2009
--------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

--------------------------------------------------------

entity Merge_Bits_tb is

end Merge_Bits_tb;

--------------------------------------------------------

architecture test of Merge_Bits_tb is

  component Merge_Bits
    port(b0 : in std_logic;
         b1 : in std_logic;
         Q  : out std_logic_vector(1 downto 0));
  end component;

  -- component ports
  signal b0  : std_logic;
  signal b1  : std_logic;
  signal Q   : std_logic_vector(1 downto 0);

  constant step : time := 10 ns;

begin

  -- component instantiation
  MUX2comp: Merge_Bits
    port map(b0  => b0,
             b1  => b1,
             Q   => Q);

  test_proc: process

  begin
    b0 <= '0';
    b1 <= '0';
    wait for step;

    b0 <= '1';
    b1 <= '0';
    wait for step;

    b0 <= '0';
    b1 <= '1';
    wait for step;

    b0 <= '1';
    b1 <= '1';
    wait for step;

    b0 <= '1';
    b1 <= '0';
    wait for step;

    b0 <= '0';
    b1 <= '0';
    wait for step;

    wait;
  end process test_proc;

end test;

--------------------------------------------------------
