--------------------------------------------------------
-- VHDL code per Merge di 2 vettori in un unico
-- std_logic_vector.
-- By Sebastiano Otupacca - PAP1 2008/2009, 06-05-2009
--------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

--------------------------------------------------------

entity Merge_Vectors is

  generic(nV0: natural := 8; nV1: natural := 8);
  port(v0 : in std_logic_vector(nV0-1 downto 0);        -- Vector low
       v1 : in std_logic_vector(nV1-1 downto 0);        -- Vector high
       Q  : out std_logic_vector(nV0+nV1-1 downto 0));  -- Vector merge output

end Merge_Vectors;

--------------------------------------------------------

architecture rtl of Merge_Vectors is

begin

  Q <= v1 & v0;

end rtl;

--------------------------------------------------------
