--------------------------------------------------------
-- VHDL code per porta NOT a 1 e a n-bit.
-- By Sebastiano Otupacca - PAP1 2008/2009, 09-05-2009
--------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

--------------------------------------------------------

entity NOT1 is

  port(D : in std_logic;
       Q : out std_logic);

end NOT1;

--------------------------------------------------------

architecture rtl of NOT1 is

begin

  Q <= not D;

end rtl;

--------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

--------------------------------------------------------

entity NOTx is

  generic(n: natural := 8);
  port(D : in std_logic_vector(n-1 downto 0);
       Q : out std_logic_vector(n-1 downto 0));

end NOTx;

--------------------------------------------------------

architecture struct of NOTx is

  component NOT1
    port(D : in std_logic;
         Q : out std_logic);
  end component;

begin

  -- Istanzia n volte la cella 'NOT1' ad 1 bit
  genNOT: for i in 0 to n-1 generate
            cell: NOT1 port map(D => D(i),
                                Q => Q(i));
  end generate;

end struct;

--------------------------------------------------------
