--------------------------------------------------------
-- VHDL code per serie di porte XOR a 2 input.
-- By Sebastiano Otupacca - PAP1 2008/2009, 06-05-2009
--------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

--------------------------------------------------------

entity XOR2 is

  port(A : in std_logic;    -- Input A
       B : in std_logic;    -- Input B
       Q : out std_logic);  -- XOR output

end XOR2;

--------------------------------------------------------

architecture rtl of XOR2 is

begin

  Q <= A xor B;

end rtl;

--------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

--------------------------------------------------------

entity XOR2_Serie is

  generic(n: natural := 8);
  port(A : in std_logic_vector(n-1 downto 0);    -- Inputs A
       B : in std_logic_vector(n-1 downto 0);    -- Inputs B
       Q : out std_logic_vector(n-1 downto 0));  -- XORs output

end XOR2_Serie;

--------------------------------------------------------

architecture struct of XOR2_Serie is

  component XOR2
    port(A : in std_logic;    -- Input A
         B : in std_logic;    -- Input B
         Q : out std_logic);  -- XOR output
  end component;

begin

  -- Istanzia n volte la cella 'XOR_Port' ad 1 bit
  genBuf: for i in 0 to n-1 generate
            cell: XOR2 port map(A => A(i),
                                B => B(i),
                                Q => Q(i));
  end generate;

end struct;

--------------------------------------------------------
